<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">
</head>
<body onload="onLoadPaging()">
    <div class="container jumbotron">
        <h1 class="text-center p-lg-1">Thông tin người dùng</h1>
        <div class="form-group">
            <label for="">First Name</label>
            <input type="text" id="input-first-name" class="form-control">
        </div>
        <div class="form-group">
            <label for="">Last Name</label>
            <input type="text" id="input-last-name" class="form-control">
        </div>
        <div class="form-group">
            <label for="">Country</label>
            <input type="text" id="input-country" class="form-control">
        </div>
        <div class="form-group">
            <label for="">Subject</label>
            <textarea name="" id="textarea-subject" class="form-control"></textarea>
        </div>
        <div class="form-row">
            <div class="col">
                <button id="button-edit" class="btn btn-success w-50" onclick="onBtnUpdateUserDetailClick()">Sửa</button>
            </div>
            <div class="col">
                <a id="back-to-list-view-a-tag" href="index.html" class="nav justify-content-end" onclick="onBtnBackToListViewClick()">Quay lại</a>
            </div>
        </div>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREGISTER_USER_INFOR_URL = "index.html";
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-register-java-api/users"
        const gJSON_CONTENT_TYPE = "application/json;charset=UTF-8";
    
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onLoadPaging() {
            // 1. Đọc dữ liệu (đọc dữ liệu từ query string)
            var vId = docDuLieu();
            
            // 2. Kiểm tra dữ liệu
            var vIdIsValid = kiemTraUserID(vId);
            if(vIdIsValid) {
                // 3. Gọi API
                var vXmlHttp = new XMLHttpRequest();
                callAPIToGetUserInfoByUserId(vXmlHttp, vId);
                // kiểm tra trạng thái trả về từ Server để tiếp tục thực hiện việc hiển thị dữ liệu lên Web
                vXmlHttp.onreadystatechange = function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        // 4. hiển thị thông tin chi tiết của User lên form
                        showUserDetailToForm(vXmlHttp.responseText);
                    }
                }
            }
        }

        // Hàm cập nhật thông tin User hiện tại
        function onBtnUpdateUserDetailClick() {
            /* Task 29.80 Sửa dữ liệu ở form Thông Tin Chi Tiết
                Sau đó, nếu dữ liệu hợp lệ thì tiến hành gọi API cập nhật thông tin và quay lại trang Thông Tin Đăng Ký Người Dùng
                => Tiến trình gồm 4 bước: (mỗi bước là một function để đặc tả)
            */
            // gán nội dung của đối tượng User cho biến đã tạo
            var vUserObject = declareAndInitializeUserObject();
            // B1. Đọc dữ liệu người dùng nhập từ Form (mục đích update)
            docDuLieuTrenFormChiTiet(vUserObject);

            // B2. Kiểm tra dữ liệu nhập trên Form
            var isValid = kiemTraDuLieuTrenForm(vUserObject);
            if(isValid) {
                // 3. Gọi API để tiến hành cập nhật dữ liệu User
                // gọi hàm docDuLieu để lấy giá trị UserId
                var vId = docDuLieu();
                var vXmlHttp = new XMLHttpRequest();
                // tiến hành gọi API Update để cập nhật
                updateUserDetailById(vUserObject, vXmlHttp, vId);
                // 4. Xử lý hiển thị (nếu cập nhật thành công thì bấm nút quay lại và sẽ thấy thông tin User được cập nhật)
                // Thực hiện ở hàm sự kiện onBtnBackToListViewClick() như bên dưới
            }
        }

        // Hàm quay lại trang ListView để xem dữ liệu đã cập nhật
        function onBtnBackToListViewClick() {
            /* Quay lại trang Danh Sách Người Dùng Đăng Ký để kiểm tra dữ liệu đã cập nhật
                Dùng phương thức setAttribute() để thay đổi thuộc tính href của một đối tượng a */
            var vATagElement = document.getElementById("back-to-list-view-a-tag");
            vATagElement.setAttribute("href", gREGISTER_USER_INFOR_URL);
            vATagElement.click();
        }
    
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm khai báo và khởi tạo đối tượng User để lưu dữ liệu
        function declareAndInitializeUserObject() {
            var vUserObject = {
                firstname: "",
                lastname: "",
                country: "",
                subject: "",
                customerType: "",
                registerStatus: ""
            }
            return vUserObject;
        }

        // Hàm lấy UserId từ query string trên Url
        function docDuLieu() {
            var vId = 0;
            // get data from query string
            var vUrlString = window.location.href; //đường đẫn gọi đến trang
            var vUrl = new URL(vUrlString);
            // get parameters
            vId = vUrl.searchParams.get("id");
            return vId;
        }

        // Hàm kiểm tra UserId có trên querystring không
        function kiemTraUserID(paramUserId) {
            var vChecked = true;
            if(paramUserId == "" || paramUserId == null) {
                alert("UserId không hợp lệ!");
                // quay lại trang Danh Sách Người Dùng Đăng Ký nếu dữ liệu UserID không hợp lệ
                window.location.href = gREGISTER_USER_INFOR_URL;
                vChecked = false;
            }
            return vChecked;
        }

        // Hàm gọi API lấy thông tin User theo UserId
        function callAPIToGetUserInfoByUserId(paramXmlHttp, paramUserId) {
            paramXmlHttp.open("GET", gBASE_URL + "/" + paramUserId, true);
            paramXmlHttp.send();
        }

        // Hàm hiển thị thông tin chi tiết của người dùng lên form
        function showUserDetailToForm(paramJSONUser) {
            var vUserObject = JSON.parse(paramJSONUser);
            // Truy xuất đến các thành phần HTML trên form
            var vFistNameInput = document.getElementById("input-first-name");
            var vLastNameInput = document.getElementById("input-last-name");
            var vCountryInput = document.getElementById("input-country");
            var vSubjectTextarea = document.getElementById("textarea-subject");
            // gán giá trị của từng thuộc tính của object User để điền dữ liệu user vào các trường trên form
            vFistNameInput.value = vUserObject.firstname;
            vLastNameInput.value = vUserObject.lastname;
            vCountryInput.value = vUserObject.country;
            vSubjectTextarea.value = vUserObject.subject;
        }

        // Hàm đọc dữ liệu từ form Thông Tin Chi Tiết
        function docDuLieuTrenFormChiTiet(paramUser) {
            // truy xuất các element HTML trên form Chi Tiết
            var vFirstNameInput = document.getElementById("input-first-name");
            var vLastNameInput = document.getElementById("input-last-name");
            var vCountryInput = document.getElementById("input-country");
            var vSubjectTextarea = document.getElementById("textarea-subject");
            // lưu thông tin User vào đối tượng
            paramUser.firstname = vFirstNameInput.value.trim();
            paramUser.lastname = vLastNameInput.value.trim();
            paramUser.country = vCountryInput.value.trim();
            paramUser.subject = vSubjectTextarea.value.trim();
        }

        // Hàm kiểm tra dữ liệu được nhập từ form
        function kiemTraDuLieuTrenForm(paramUser) {
            var vChecked = true;
            if(paramUser.firstname == "" || paramUser.lastname == "" || paramUser.country == "" ||  paramUser.subject == "") {
                alert("Các thông tin phải được nhập.");
                vChecked = false;
            }
            return vChecked;
        }

        // Hàm cập nhật dữ liệu User
        function updateUserDetailById(paramUser, paramXmlHttp, paramUserId) {
            paramXmlHttp.open("PUT", gBASE_URL + "/" + paramUserId, true);
            paramXmlHttp.setRequestHeader("Content-Type", gJSON_CONTENT_TYPE);
            paramXmlHttp.onreadystatechange = function() {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    alert(`Câp nhật thông tin User với ID: ${paramUserId} thành công.`);
                }
                else if(this.readyState != gREQUEST_READY_STATUS_FINISH_AND_OK && this.status != gREQUEST_STATUS_OK) {
                    alert(`Câp nhật thông tin User với ID: ${paramUserId} thất bại.`);
                }
            }
            // gửi JSON String đến Server để cập nhật thông tin mới cho User (convert sang JSON Stirng trước khi request)
            paramXmlHttp.send(JSON.stringify(paramUser));
        }

      </script>
</body>
</html>